/*	File:	missile.c
	Author:	Alex Fedosov, Jeff Malch
	Date:	March 15, 2001
	Description:	missile code
*/

#include <stdio.h>
#include <string.h>

#include "common/const.h"
#include "common/errors.h"
#include "common/object.h"
#include "common/msg.h"
#include "common/move.h"
#include "common/attack.h"
#include "common/util.h"

#include "dmzcore.h"
#include "dmz_net.h"

char buf[256];

GLOBAL WORD16 missile;
GLOBAL WORD16 explosion;

/* create a missile for projectile attacks */
void MissileAttack(WORD16 attacker, WORD16 direction)
{
	WORD16 missile_id;
	int mx = 0, my = 0;

	if (dmz_objects[attacker]->u.player.ammo > 0)
		dmz_objects[attacker]->u.player.ammo -= 1;
	else
		return;
	
/*	direction = dmz_objects[attacker]->u.player.direction;
*/
	/* determine proper position for missile based on direction */
	dmz_scale_delta(direction, &mx, &my);
	mx = (mx * PIXELS_PER_CELL) + dmz_objects[attacker]->x;
	my = (my * PIXELS_PER_CELL) + dmz_objects[attacker]->y;

	/* create a missile */
	missile_id = dmz_new_object(0, MISSILE, mx, my);
	strcpy(dmz_objects[missile_id]->name, "missile");

	/* fill in missile attributes */
	dmz_objects[missile_id]->u.missile.damage = MISSILE_DAMAGE;
	dmz_objects[missile_id]->u.missile.range = MISSILE_RANGE;
	dmz_objects[missile_id]->u.missile.direction = direction;
	dmz_objects[missile_id]->u.missile.owner = attacker;
	dmz_objects[missile_id]->u.missile.exp_frame = 0;
	dmz_objects[missile_id]->u.missile.exp_ttl = EXPLOSION_TTL;

	/* TODO missile bitmap */
	dmz_objects[missile_id]->bitidx = missile;
	dmz_objects[missile_id]->deadbit = explosion;
	dmz_objects[missile_id]->width = MISSILE_WIDTH;//DEFAULT_WIDTH;
	dmz_objects[missile_id]->height = MISSILE_HEIGHT;//DEFAULT_HEIGHT;
}
