/*	File:	upgrade.c
	Author:	Nancy Montanez
	Date:	April 3, 2001
	Description:	robot upgrade code
*/

#include "common/const.h"
#include "common/object.h"
#include "common/upgrade.h"

#define LEVEL1 100
#define LEVEL2 200
#define LEVEL3 300

void UpgradePlayer(WORD16 player_id)
{
	int level = UpgradePlayerLevel(player_id);
	WORD16 default_bitmap = dmz_objects[player_id]->bitidx;

	if (dmz_objects[player_id]->objtype != PLAYER) return;

	default_bitmap -= ((dmz_objects[player_id]->bitidx / MAXUPGRADES) * MAXCOLORS);

	if (level > 0)
		dmz_objects[player_id]->bitidx = default_bitmap + (MAXCOLORS * level);
}

int UpgradePlayerLevel(WORD16 player_id)
{
	int rv = 0;

	if (dmz_objects[player_id]->score >= LEVEL3 &&
		dmz_objects[player_id]->u.player.level < 3)
		rv = dmz_objects[player_id]->u.player.level = 3;

	else if (dmz_objects[player_id]->score >= LEVEL2 &&
		dmz_objects[player_id]->u.player.level < 2)
		rv = dmz_objects[player_id]->u.player.level = 2;

	else if (dmz_objects[player_id]->score >= LEVEL1 &&
		dmz_objects[player_id]->u.player.level < 1)
		rv = dmz_objects[player_id]->u.player.level = 1;

	return rv;
}
