/*	File:	const.h
	Author:	Alex Fedosov
	Date:	October 19, 2000
	Description:	common constants
*/

#ifndef __DMZ_CONST_H__
#define __DMZ_CONST_H__

/* general */
#define DMZ_SERVER "138.202.170.102"
#define DMZPORT 3210
#define DMZ_RANDOM_SEED 0x65498731
#define MAP_FILE		"dmz_map.bmp"
#define TERRAIN_CSV		"dmz_terrain.csv"
#define OBJECTS_CSV		"dmz_objects.csv"
#define MONSTERS_CSV	"dmz_monsters.csv"
#define ITEMS_CSV		"dmz_items.csv"
#define NPC_CSV			"dmz_npc.csv"

/* map */
#define MAPWIDTH 256
#define MAPHEIGHT 256
#define MAXCELLS 4099
#define	MAX_MAP_CELLS 256
#define START_POS_X 100
#define START_POS_Y 100
#define PIXELS_PER_CELL 32

/* objects */
#define MAXCOLORS 4
#define MAXUPGRADES 4
#define DEFAULT_LIFE 100
#define DEFAULT_DIR 1
#define DEFAULT_VELOCITY 5
#define MISSILE_VELOCITY 15
#define MISSILE_DAMAGE 4
#define MISSILE_RANGE 18	/* velocity * range = range in pixels */
#define EXPLOSION_TTL 10	/* explosions last for half a second */
#define MAXOBJECTS 4096
#define MAX_INV 8
#define HTH_DAMAGE 10
#define NAMELEN 32
#define DEFAULT_AMMO 100
#define DEFAULT_WIDTH 32
#define DEFAULT_HEIGHT 32
#define MISSILE_WIDTH 16
#define MISSILE_HEIGHT 16
#define MONSTER_REGEN 10
#define ITEM_REGEN 5

/* network */
#define MAXMSGDATA 128
#define NETWORK_TIMEOUT 10	/* network timeout in seconds */

#endif
