//-----------------------------------------------------------------------------
// File: dmz_graphics.h
//
// Written by: Emory Al-Imam
// Date: October 17, 2000
// Date: October 17, 2000
// Desc: DMZ  graphics API
//-----------------------------------------------------------------------------

#ifndef __DMZ_GRAPHICS_H__
#define __DMZ_GRAPHICS_H__

#ifdef WIN32
	#ifdef __cplusplus
		#ifdef DMZ_GRAPHICS_EXPORTS
			#define DMZ_GRAPHICS_API extern "C" __declspec(dllexport)
		#else
			#define DMZ_GRAPHICS_API extern "C" __declspec(dllimport)
		#endif
	#else
		#ifdef DMZ_GRAPHICS_EXPORTS	
			#define DMZ_GRAPHICS_API __declspec(dllexport)
		#else
			#define DMZ_GRAPHICS_API __declspec(dllimport)
		#endif
	#endif
#else
	#define DMZ_GRAPHICS_API
#endif

// Function Prototypes
DMZ_GRAPHICS_API int	dmz_graph_flip(void);
DMZ_GRAPHICS_API void	dmz_graph_kill(void);
DMZ_GRAPHICS_API int	dmz_graph_init(void* hwnd);
DMZ_GRAPHICS_API int	dmz_graph_load_pal(char* filename);
DMZ_GRAPHICS_API int	dmz_graph_load_bmp(char* filename);
DMZ_GRAPHICS_API int	dmz_graph_set_display(int screen_width, int screen_height, int color_depth);
DMZ_GRAPHICS_API int	dmz_graph_blit(int bmpID, int source_x, int source_y, int source_width, 
									   int source_height, int dest_x, int dest_y, int is_trnsprncy);
// Error Codes
typedef enum {
		DMZ_GRAPH_SUCCESS		=  0,	// functions returned successfully
		DMZ_GRAPH_OPEN_ERR		= -1,	// error opening specified file
		DMZ_GRAPH_ALREADY_INIT  = -2,	// graphics library already initialized
		DMZ_GRAPH_DD_ERR		= -3,	// DirectDraw Error
		DMZ_GRAPH_NOT_INIT		= -4,	// graphics library not yet initialized
		DMZ_GRAPH_TOO_MANY		= -5,	// cannot allocate any more surfaces, array already filled up
		DMZ_GRAPH_SET_DISP_ERR  = -6,	// could not seup the display mode
		DMZ_GRAPH_SET_PAL_ERR   = -7,	// could not setup up palette
} DMZ_GRAPH_RV;

#endif