/*	File:	lock.h
	Author:	Alex Fedosov
	Date:	November 21, 2000
	Description:	locking primitives
*/

#ifndef __DMZ_LOCK_H__
#define __DMZ_LOCK_H__

#if defined (__GNUC__) && defined (unix)
	#include "sys/gnu/smp-lock.h"
	#define lock_t			smp_lock_t
	#define lock_init		smp_lock_init
	#define lock_destroy	smp_lock_free
	#define mutex_lock		smp_lock_acquire
	#define mutex_unlock	smp_lock_release

	#define __lock_t		smp_lock_t
	#define __lock_init		smp_lock_init
	#define __lock_destroy	smp_lock_free
	#define __mutex_lock	smp_lock_acquire
	#define __mutex_unlock	smp_lock_release

#elif defined (_MSC_VER) && defined (_WIN32)
	#include "sys/win32/lock.h"
#else
	#error "Sorry, unsupported compiler / target."
#endif

#endif
