/*	File:	input.c
	Author:	Alex Fedosov, Jeff Malch
	Date:	January 31, 2001
	Description:	Routines to handle input from user
*/

#include <windows.h>

#include "client.h"

struct keyboardState kb[MAXKBKEYS];

void dmz_read_keyboard(void)
{
	/* move north */
	if(GetAsyncKeyState(VK_UP) & 0x8000)
		kb[VK_UP].down = 1;
	else
		kb[VK_UP].down = 0;

	/* move south */
	if(GetAsyncKeyState(VK_DOWN) & 0x8000)
		kb[VK_DOWN].down = 1;
	else
		kb[VK_DOWN].down = 0;

	/* move west */
	if(GetAsyncKeyState(VK_LEFT) & 0x8000)
		kb[VK_LEFT].down = 1;
	else
		kb[VK_LEFT].down = 0;

	/* move east */
	if(GetAsyncKeyState(VK_RIGHT) & 0x8000)
		kb[VK_RIGHT].down = 1;
	else
		kb[VK_RIGHT].down = 0;	

	/* move northwest */
	if(GetAsyncKeyState(VK_NUMPAD7) & 0x8000)
		kb[VK_NUMPAD7].down = 1;
	else
		kb[VK_NUMPAD7].down = 0;

	/* move north */
	if(GetAsyncKeyState(VK_NUMPAD8) & 0x8000)
	    kb[VK_NUMPAD8].down = 1;
	else
		kb[VK_NUMPAD8].down = 0;	

	/* move northeast */
	if(GetAsyncKeyState(VK_NUMPAD9) & 0x8000)
		kb[VK_NUMPAD9].down = 1;
	else
		kb[VK_NUMPAD9].down = 0;

	/* move west */
	if(GetAsyncKeyState(VK_NUMPAD4) & 0x8000)
		kb[VK_NUMPAD4].down = 1;
	else
		kb[VK_NUMPAD4].down = 0;

	/* move east */
	if(GetAsyncKeyState(VK_NUMPAD6) & 0x8000)
			kb[VK_NUMPAD6].down = 1;
	else
		kb[VK_NUMPAD6].down = 0;

	/* move southwest */
	if(GetAsyncKeyState(VK_NUMPAD1) & 0x8000)
		kb[VK_NUMPAD1].down = 1;
	else
		kb[VK_NUMPAD1].down = 0;

	/* move south */
	if(GetAsyncKeyState(VK_NUMPAD2) & 0x8000)
		kb[VK_NUMPAD2].down = 1;
	else
		kb[VK_NUMPAD2].down = 0;

	/* move southeast */
	if(GetAsyncKeyState(VK_NUMPAD3) & 0x8000)
		kb[VK_NUMPAD3].down = 1;
	else
		kb[VK_NUMPAD3].down = 0;

	/* range attack */
	if(GetAsyncKeyState(VK_CONTROL) & 0x8000)
		kb[VK_CONTROL].down = 1;
	else
		kb[VK_CONTROL].down = 0;

	/* hth attack */
	if(GetAsyncKeyState(VK_NUMPAD0) & 0x8000)
		kb[VK_NUMPAD0].down = 1;
	else
		kb[VK_NUMPAD0].down = 0;
	
	if(GetAsyncKeyState('W') & 0x8000)
		kb['W'].down = 1;
	else
		kb['W'].down = 0;
}

int dmz_get_keyboard_input(int *dx, int *dy)
{
	int directionY = 0, directionX = 0;
	int i = 0;	

	if (dx == NULL || dy == NULL)
		return DMZ_BAD_PARAM;

	if(kb[VK_UP].down || kb[VK_NUMPAD8].down)
		directionY = -1;

	if(kb[VK_DOWN].down || kb[VK_NUMPAD2].down)
		directionY = 1;

	if(kb[VK_LEFT].down || kb[VK_NUMPAD4].down)
		directionX = -1;

	if(kb[VK_RIGHT].down || kb[VK_NUMPAD6].down)
		directionX = 1;

	if(kb[VK_NUMPAD7].down)
	{
		directionX = -1;
		directionY = -1;
	}

	if(kb[VK_NUMPAD9].down)
	{
		directionX = 1;
		directionY = -1;
	}

	if(kb[VK_NUMPAD1].down)
	{
		directionX = -1;
		directionY = 1;
	}

	if(kb[VK_NUMPAD3].down)
	{
		directionX = 1;
		directionY = 1;
	}

	*dx = directionX;
	*dy = directionY;
	
	return DMZ_SUCCESS;
}

int dmz_get_cursor_loc(int *mouseX, int *mouseY)
{
	POINT coord;

	if (GetCursorPos(&coord) == FALSE)
		return DMZ_MOUSE_ERROR;
	
	*mouseX = coord.x;
	*mouseY = coord.y;

	return DMZ_SUCCESS;
}
